%%%%%%%%%%%%%%%% v 3.0 - Real Adaboost %%%%%%%%%%%%%%%%%%%%%%
function detectionVehicleRealCascade

global HAAR_TYPE HOG_TYPE NROBINS WIND_SIZE;

HAAR_TYPE   = 0;
HOG_TYPE    = 1;
NROBINS     = 128;
WIND_SIZE   = 32;

addpath('..\Functions');
% script detection with the Haar wavelets using the 200 features classifier
load CascadeDetector;
[pipo,STAGES]=size(C);
TOTVEHICLES=0;
NROSCALES = 7;
N=4;
load index_Haar;
load index_HoG;
% read file
[file,testpath]  = uigetfile('..\Images\Test\*.jpeg');
    
% lecture de l'image
ima = imread([testpath '\' file]);

[u,v,z]=size(ima);
if z > 1
    ima = rgb2gray(ima);
end
ima = double(ima);
ii = imageIntegrale(ima);   
% for standard deviation calcul
ima2 = ima.^2;
ii2 = imageIntegrale(ima2);
    
[m,o]=getgradsobel(ima,N);
% clean bords
m(1,:)=0;m(end,:)=0;
m(:,1)=0;m(:,end)=0;
% calculate the histogram integral
hh = getHistogramIntegral(m,o,N);

% redimensionner la matrice
iii = [zeros(1,v+1); zeros(u,1) ii];
for i=1:N
    hhh(:,:,i) = [zeros(1,v+1); zeros(u,1) hh(:,:,i)];
end
iii2 = [zeros(1,v+1); zeros(u,1) ii2];
% We going to slide window over the image with the scale of the vehicles
% in the image
box = [];
nro_box = 0;
for k=1:NROSCALES,
    sc_box = [];
    sc_nro_box = 0;
    dxy=WIND_SIZE*k;
    i=1;j=1;
% First stage: box list creation
    hj = C{1}.hj;
    while i+dxy <= u
        while j+dxy <= v           
            s = getRectangleStandardDeviation([i j dxy],iii,iii2);            	
            acc_sum = detectionOnRectangle([i j dxy],iii,hhh,s,hj,index_Haar,index_HoG);
    % record the window if the error is lower than the threshold
            if acc_sum > C{1}.threshold
                sc_box = [sc_box;[i j dxy dxy s]]; %[colonne ligne dxy dxy]
                sc_nro_box = sc_nro_box + 1;
            end       
            j = j + dxy / 4;
        end
        j = 1;
        i = i + dxy / 4;
    end
    for t=2:STAGES,
        hj = C{t}.hj;
        sc_nro_temp = 0;
        sc_box_temp = [];
        for b=1:sc_nro_box,
            j=sc_box(b,2);i=sc_box(b,1);dxy=sc_box(b,3);               
            s = sc_box(b,5);
          	acc_sum = detectionOnRectangle([i j dxy],iii,hhh,s,hj,index_Haar,index_HoG);
            if acc_sum > C{t}.threshold
                sc_box_temp = [sc_box_temp ; sc_box(b,:)];
                sc_nro_temp = sc_nro_temp + 1;
            end
        end
        sc_nro_box = sc_nro_temp;
        sc_box = sc_box_temp;
    end
    box = [box ; sc_box];
    nro_box = nro_box + sc_nro_box;
end
handle=drawRectangle(ima,box,nro_box);    
saveas(handle,[testpath 'test_' file ],'tif');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% function drawRectangle(i,box,nro_box)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function handle = drawRectangle(i,box,nro_box)
% fonction drawRectangle(image,box -> [ y x dw dh], nro_boxes)
figure;
handle=imagesc(i);colormap(gray);
hold on;
for j=1:nro_box
    plot([box(j,2) box(j,2)+box(j,3) box(j,2)+box(j,3) box(j,2) box(j,2)],...
    [box(j,1) box(j,1) box(j,1)+box(j,4) box(j,1)+box(j,4) box(j,1)],'r-','LineWidth',2);
end
hold off;
