%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function acc_sum = detectionOnRectangle(rect,ii,hh,s,hj,index_Haar,index_HoG)

global HAAR_TYPE HOG_TYPE NROBINS;

%get number of features from the classifier
[pipo,nfts]=size(hj);
acc_sum = 0;
for i=1:nfts,
    switch hj{i}.type
        case HAAR_TYPE
            ft = getRectangleSingleHaarFeature(rect,ii,index_Haar(hj{i}.feature,:),s);
            idx = floor((ft / hj{i}.maxval) * NROBINS) + 1;
                % verify values
          	if idx>NROBINS, idx=NROBINS;end         
            acc_sum = acc_sum + hj{i}.fm(idx);
        case HOG_TYPE
            hx = getRectangleSingleHoGFeature(rect,hh,index_HoG(hj{i}.feature,:));
            ft = getHistogramDistance(hx,hj{i}.hmodel);
         	idx = floor(ft * NROBINS) + 1;
          	% verify value
          	if idx>NROBINS, idx=NROBINS;end         
           	acc_sum = acc_sum + hj{i}.fm(idx);
    end
end

