%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% function fx = getImageSingleHaarFeature(iii,ft_Haar,ws,s)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function fx = getRectangleSingleHaarFeature(rect,iii,ft_Haar,s)
% rect      : [lin col dxy]
% ii        : image integrale
% ft_Haar   : feature description
% ws        : window size
% s         : standard deviation of gray scale image
global WIND_SIZE;

dxy = rect(3);
sc=ft_Haar(3);
pas = dxy / WIND_SIZE;
% Feature 
x=rect(2)+round((ft_Haar(4)-1)*pas);
y=rect(1)+round((ft_Haar(5)-1)*pas);
dx = round(sc * pas);

switch ft_Haar(2)
    case 1
        fx = iii(y,x) + 2 * iii(y+dx,x+dx) + iii(y,x+2*dx) - ...
            2 * iii(y,x+dx) - iii(y+dx,x) - iii(y+dx,x+2*dx);
    case 2
        fx = iii(y,x) + 2 * iii(y+dx,x+dx) + iii(y+2*dx,x) - ...
            2 * iii(y+dx,x) - iii(y,x+dx) - iii(y+2*dx,x+dx);
    case 3
        fx = (iii(y+dx,x+3*dx) + iii(y,x) - (iii(y,x+3*dx)+iii(y+dx,x))) - ...
            3 * (iii(y+dx,x+2*dx) + iii(y,x+dx+1) - ...
            (iii(y,x+2*dx)+iii(y+dx,x+dx+1)));
    case 4
        fx = (iii(y+3*dx,x+dx) + iii(y,x) - (iii(y+3*dx,x)+iii(y,x+dx))) - ...
            3 * (iii(y+2*dx,x+dx) + iii(y+dx+1,x) - ...
            (iii(y+dx+1,x+dx)+iii(y+2*dx,x)));
end
if s > 0, fx = fx / s;end
fx=abs(fx)/pas^2;
