%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% function hx = getImageSingleHoGFeature(hh,ft_HoG,ws)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function hx = getRectangleSingleHoGFeature(rect,hh,ft_HoG)
% rect      : [lin col dxy]
% hh : histogram integrale
% ft_HoG
% ws : window size
global WIND_SIZE;

[u,v,N] = size(hh);
sc=ft_HoG(3);

pas = rect(3) / WIND_SIZE;
% Feature 
x=rect(2)+round((ft_HoG(4)-1)*pas);
y=rect(1)+round((ft_HoG(5)-1)*pas);
dx = round(sc * pas);
hx = zeros(1,N);
switch ft_HoG(2)
    case 1
        for i=1:N 
            hx(i) = abs(hh(y+dx,x+dx,i)+hh(y,x,i)-(hh(y,x+dx,i)+hh(y+dx,x,i)));
        end
    case 2
        for i=1:N 
            hx(i) = abs(hh(y+dx,x+2*dx,i)+hh(y,x,i)-(hh(y,x+2*dx,i)+hh(y+dx,x,i)));
        end
    case 3
        for i=1:N 
            hx(i) = abs(hh(y+2*dx,x+dx,i)+hh(y,x,i)-(hh(y,x+dx,i)+hh(y+2*dx,x,i)));
        end
end
idx = find(hx < 1);
if ~isempty(idx), hx(idx)=0;end
if sum(hx) > 0
    hx=hx/sum(hx);
end
