%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% FUNCTION INTEGRAL IMAGE
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function img_int = imageIntegrale(img)
% Fonction qui calcule l'image integrale
[u,v,d] = size(img);
if d > 1
    img = rgb2gray(img);
end

ii = zeros(u+1,v+1);
% resize de l'image. nous ajoutons une ligne et une colonne des zeros.
s = [zeros(1,v+1) ; zeros(u,1) double(img)];

for i=2:u+1,
    for j=2:v+1,
        s(i,j)=s(i,j-1)+double(img(i-1,j-1));
        ii(i,j)=ii(i-1,j)+s(i,j);
    end
end
img_int=ii(2:u+1,2:v+1);
