%%%%%%%%%%%%%%%% v 3.0 - Real Adaboost %%%%%%%%%%%%%%%%%%%%%%
function getData

global WIND_SIZE;
WIND_SIZE = 32;

% lecture du dossier
addpath('..\Functions');
addpath('..\Functions\c');
base_path = '..\images\Positives';
N = 4; 
P_haar  = [];
P_hog   = [];

load index_Haar
load index_HoG

fid=fopen([base_path '\info.dat'],'r');
while 1
    tline = fgets(fid);
    if tline == -1
        break;
    end
    spc = strfind(tline,' ');
    name = tline(1:spc(1)-1);
    % vehicle box : nro_boxs x y dx dy
    dat = sscanf(tline(spc(1):max(spc)),'%i %i %i %i %i');
    % read image
    img = imread([base_path '\' name]);
    imagette = img(dat(3):dat(3)+dat(4),dat(2):dat(2)+dat(4));
    
    [u,v,z]=size(imagette);
    if z > 1
        imagette = rgb2gray(imagette);
    end
    % resize the image to the canonical pattern
    img = double(imresize(imagette,[32 32],'nearest'));
	[haar_data,hog_data] = getSampleFeatures(img,N,index_Haar,index_HoG);
    P_haar  = [P_haar haar_data];
    P_hog   = [P_hog hog_data];
%     % Flip the image to double the positives number
%     img = fliplr(img);
% 	[haar_data,hog_data] = getSampleFeatures(img,N,index_Haar,index_HoG);
%     P_haar  = [P_haar haar_data];
%     P_hog   = [P_hog hog_data];
end
fclose(fid);
save('..\TrainBoost\vehicule_positive_32','P_haar','P_hog');


function [haar_data,hog_data] = getSampleFeatures(img,N,index_Haar,index_HoG)
x = 1;y = 1;dxy = 32;
rect = [x y dxy];
ii = imageIntegrale(img);
[m,o]=getgradsobel(img,N);
% clean bords
m(1,:)=0;m(end,:)=0;
m(:,1)=0;m(:,end)=0;
% calculate histogram integral
hh = getHistogramIntegral(m,o,N);
% resize matrix
iii = [zeros(1,32+1); zeros(32,1) ii];
for i=1:N
    hhh(:,:,i) = [zeros(1,32+1); zeros(32,1) hh(:,:,i)];
end
img2 = img.^2;
ii2 = imageIntegrale(img2);
iii2 = [zeros(1,32+1); zeros(32,1) ii2];
s = getRectangleStandardDeviation(rect,iii,iii2);
% Get Haar data
haar_data = getHaarData_c(rect,iii,index_Haar,s);
% Get HoG data
hog_data = getHoGData_c(rect,hhh,N,index_HoG);



