function script_get_HoG_index
% Calculate the linear HoG index to (x,y) format:
% The output file has 5 columns and each of them means:
% 1-	feature index number
% 2-	the type of the HoG feature (in this implementation this number 
%       is the same for all the features, but I used to have more than 
%       one when I worked with squares and rectangles regions).
% 3-	The size of the square (in pixels)
% 4-	The x position (assuming the patch has size 32x32 pixels)
% 5-	The y position

u=32;v=32;
index_HoG = [];
acc_index = 1;
for sc=[6 8]
    q_w = v - sc;
    q_h = u - sc;
    % Feature 
    for i=1:q_w, % colonnes
        for j=1:q_h, % lines
            index_HoG = [index_HoG ; acc_index 1 sc i j];  % [fts n_fts sc x y]
            acc_index = acc_index+1;
        end
    end
    q_w = v - 2*sc;
    q_h = u - sc;
    % Feature 
    for i=1:q_w, % colonnes
        for j=1:q_h, % lines
            index_HoG = [index_HoG ; acc_index 2 sc i j];  % [fts n_fts sc x y]
            acc_index = acc_index+1;
        end
    end
    q_w = v - sc;
    q_h = u - 2*sc;
    % Feature 
    for i=1:q_w, % colonnes
        for j=1:q_h, % lines
            index_HoG = [index_HoG ; acc_index 3 sc i j];  % [fts n_fts sc x y]
            acc_index = acc_index+1;
        end
    end
end
save('index_HoG','index_HoG');
save('..\Detection\index_HoG','index_HoG');
save('..\TrainBoost\index_HoG','index_HoG');
