%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
% [cm,fm]=computeRealAdaboostParameters(p,n,T,PD);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
function [fm,Z]=computeRealAdaboostParameters(p,n,T,PD);
[pipo,NRO_POS]=size(p);
[pipo,NRO_NEG]=size(n);
pd_pos = PD(1:NRO_POS);
pd_neg = PD(NRO_POS+1:NRO_POS+NRO_NEG);
    
e_smooth = 1 / (NRO_POS+NRO_NEG);

pd_p=smooth(histc_1D(p,0:1:128,pd_pos)');
pd_n=smooth(histc_1D(n,0:1:128,pd_neg)');

fm = 0.5*log((pd_p+e_smooth)./(pd_n+e_smooth))';

sc = 0.5 * log(1/(2 * e_smooth));

fm = fm / sc;

x = find(fm > 1);
if ~isempty(x)
	fm(x) = 1;
end

Z = 2* sum(sqrt(pd_p.*pd_n));


