%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% FUNCTION REAL ADABOOST
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [hj,pd]  = realadaboost_fm(NHaar,NHoG,PHaar_t,PHoG_t,hj,i,pd,HoG_model,N)
% function train cascade
% Methode de boosting

global HAAR_TYPE HOG_TYPE;
load index_Haar
% Initialization des poids
% quantite des positifs et quantite des ngatifs
[NROFTS_HOG,NRO_POS]=size(PHoG_t);
[NROFTS_HAAR,NRO_POS]=size(PHaar_t);
[pipo,NRO_NEG]=size(NHaar);
if sum(pd) == 0
    pd = [ones(1,NRO_POS)/(2*NRO_POS) ones(1,NRO_NEG)/(2*NRO_NEG)];
end
T=[ones(1,NRO_POS) -1*ones(1,NRO_NEG)];
% hj_haar:
%   1-nro feature
%   2-type feature
%   3-max_feature (to normailze)
%   4-fm (1x128 elements)
% hj_hog:
%   1-nro feature
%   2-type feature
%   3-histogram model
%   4-fm (1x128 elements)
hj_i.fm = zeros(128,1);
hj_i.nro_ft = 0;

% normalisation of weights 
pd = pd / sum(pd);

% HOG
for j=1:NROFTS_HOG
    p=PHoG_t(j,:);n=NHoG(j,:);
	FACT= 128;
	[fm,Z_HOG(j)]=computeRealAdaboostParameters(p*FACT,n*FACT,T,pd);
end
[Z_HOG,idxZ_HOG] = sort(Z_HOG);
% look if the lowest feature error is already in the classifier.
k=0;
pos_eZ = 1;

vec_fts = [];
for k=1:i-1
    if hj{k}.type == HOG_TYPE
        vec_fts(k) = hj{k}.feature;
    end
end
while 1
    if i > 1 && ~isempty(vec_fts) && ~isempty(find(vec_fts == idxZ_HOG(pos_eZ))) 
    	pos_eZ=pos_eZ+1;
    else
        break;
    end
end

ftZ_HOG = idxZ_HOG(pos_eZ);
err_HOG = Z_HOG(pos_eZ);
disp(['HoG error : ' num2str(err_HOG)]);

% HAAR
for j=1:NROFTS_HAAR
    p=PHaar_t(j,:);n=NHaar(j,:);
    max_val = max([p n]);
	FACT= 128/max_val;
	[fm,Z_HAAR(j)]=computeRealAdaboostParameters(p*FACT,n*FACT,T,pd);
end
[Z_HAAR,idxZ_HAAR] = sort(Z_HAAR);
% look if the lowest feature error is already in the classifier.
k=0;
pos_eZ = 1;

vec_fts = [];
for k=1:i-1
    if hj{k}.type == HAAR_TYPE
        vec_fts(k) = hj{k}.feature;
    end
end
while 1
    if i > 1 && ~isempty(vec_fts) && ~isempty(find(vec_fts == idxZ_HAAR(pos_eZ))) 
    	pos_eZ=pos_eZ+1;
    else
        break;
    end
end

ftZ_HAAR = idxZ_HAAR(pos_eZ);
err_HAAR = Z_HAAR(pos_eZ);
disp(['Haar error : ' num2str(err_HAAR)]);

if err_HOG < err_HAAR
	p=PHoG_t(ftZ_HOG,:);n=NHoG(ftZ_HOG,:);
	FACT= 128;
	[fm,Z]=computeRealAdaboostParameters(p*FACT,n*FACT,T,pd);
	% save de classifier
	hj{i}.feature = ftZ_HOG;
	hj{i}.type = HOG_TYPE;
	hj{i}.hmodel = HoG_model(ftZ_HOG,:);
	hj{i}.fm = fm;
else
	p=PHaar_t(ftZ_HAAR,:);n=NHaar(ftZ_HAAR,:);
    max_val = max([p n]);
	FACT= 128/max_val;
	[fm,Z]=computeRealAdaboostParameters(p*FACT,n*FACT,T,pd);
	% save de classifier
	hj{i}.feature = ftZ_HAAR;
	hj{i}.type = HAAR_TYPE;
	hj{i}.maxval = max_val;
	hj{i}.fm = fm;
end
idx = floor([p*FACT n*FACT]) + 1;
% verify values
x = find(idx > 128);
if ~isempty(x), idx(x) = 128;end
hm=fm(idx);
% Update des poids
e=exp(-T.*hm);
pd=pd.*e;


